Arch CVS & SVN & GIT PKGBUILD 编写指南
From ArchWiki
| i18n |
|---|
| English |
| 正體中文 |
| 简体中文 |
Contents |
[edit] 用 makepkg 打包 CVS, SVN & GIT 文件
事实上,这个工作非常简单,您不需要什么特殊的知识。不管怎么样,您对CVS和SVN的知识懂得越多越好。很多人在 PKGBUILD 文件里面引入了不必要(译注:这个词是译者加的,在尽量不影响理解的前提下,译者可能会不自觉的使用自己的语言,后面不再声明)的自定义变量,这样会使工作变得复杂。这些看起来很复杂的语句并不是必须的,但是对于使语法结构清洗,是很有帮助的。
[edit] 一些小提示
- 给
pkgname加上-cvs或者-svn或者-git这样的后缀 (where applicable, 这个不知道怎么翻译) - 这样可以防止和非devel版本的包名混淆,比如 fluxbox-svn , fvwm-cvs 对 fluxbox , fvwm. - 您还必须小心处理 pacman 的冲突(依赖关系冲突)。比如 fluxbox-svn will 与 fluxbox 冲突。这样您就需要使用 conflicts= 字段(field)
conflicts=('fluxbox')
- 您还应该使用 provides= 字段,以便让需要 fluxbox (作者这里用fluxbox来举例)的包知道 fluxbox-svn 就是 fluxbox
provides=('fluxbox')
- 您最好不要使用(your should avoid using) replaces= ,它可能会产生不必要的麻烦
- When using/defining the cvsroot use anonymous:@ rather than anonymous@ to avoid having to press enter to give blank password OR anonymous:password@ - if a password is required.
- cvs and svn PKGBUILDs may not require a source or md5sum array but these fields must be included in the PKGBUILD if you wish to submit it to the AUR, otherwise the pkg will be rejected. They may be left blank though.
source=() md5sums=()
- 使用 CVS/SVN/GIT 的时候,我们极少用到 pkgrel 字段,因为源文件时有改动,所以我们通常用 pkgver 来标记改动(假定我们用 pkgver 来保存日期)(英文原文:It is rarely necessary to use the pkgrel field when building CVS/SVN/GIT pkgs - any changes to the pkg will often be on another day and so are usually accounted for by a change in pkgver (assuming pkgver is used to hold a date format),英语不到家,有人会翻译的mail:fluke at sfcube.net)
- 不要忘记把 svn 或者 cvs 包含在
makedepends=里面,如果必须的话(译注:如果你要从 svn 来 checkout 源码包,自然要要保证你有 svn 客户端) - 为了保证 check out(译注:cvs和svn的术语,就不翻译了) 下来的 code 的完整性,我们建立一个独立的 build 目录,比如你已经在 $startdir 把代码 ckeck out 到了 src/$_cvsmod 目录你可以:
mkdir src/$_cvsmod-build cd src/$_cvsmod-build ../$_cvsmod/configure
万一 这种方法失败了,你可以尝试:
cp -r src/$_cvsmod src/$_cvsmod-build cd src/$_cvsmod-build
- AUR的介绍中说最重要的是不要使用 backtick 扩展去创建 pkg 变量(With the introduction of the AUR it is most important to avoid using backtick execution to create pkg variables)
- 对于 cvs 包 您应该避免
pkgver=`date +%y%m%d`- (译注:this also inteferes with the functionality of the AUR.,这句话不好翻译,我不知道inteferes什么意思) 作为替代的方案,还可以用日期格式的 $pkgver 变量,并且使用 cvs -D 去获取从那个日期起的代码 (看下面) - 对于 svn 您可以使用修正号(revision number)。下面是一种简易的获取修正号的方法:
- 对于 cvs 包 您应该避免
svn log $_svntrunk --limit 1 | grep -m 1 -o "r.*" | cut -d \| -f 1 | sed s@r@@g
这条命令从 svn repo (译注:就是 svn 的源)最近额记录里面取得修正号--修正号的前面带有r字母。下面的来自于 fluxbox 的 svn 记录,修正号就在左上角,r4084。
------------------------------------------------------------------------ r4084 | mathias | 2005-07-20 19:29:01 +0100 (Wed, 20 Jul 2005) | 16 lines Changed some *Focus options, just to make some things a bit more clear. the "Sloppy" was always a bit .. unprecise.
[edit] CVS PKGBUILD 样例
这里用一个 bmp-cvs 的 PKGBUILD 来说明上面的一些技巧(一些小提示)
# Contributor: Lukas Sabota <punkrockguy318@comcast.net>
# Contributor: dibblethewrecker dibblethewrecker.at.jiwe.dot.org
pkgname=bmp-cvs
pkgver=20050728
pkgrel=1
pkgdesc="BeepMP is a multimedia player that uses the WinAmp 2.x UI, GTK2, and is based on XMMS. This will checkout and package the latest CVS version."
url="http://beepmp.sourceforge.net/"
license=
depends=('gtk2' 'libvorbis' 'alsa-lib' 'audiofile' 'libglade' 'id3lib' 'x-server')
provides=('bmp')
conflicts=('bmp')
makedepends=('cvs')
install=$pkgname.install
_cvsroot=":pserver:anonymous:@cvs.sourceforge.net:/cvsroot/beepmp"
_cvsmod="bmp"
build() {
cd $startdir/src
msg "Connecting to $_cvsmod.sourceforge.net CVS server...."
cvs -z3 -d $_cvsroot co -D $pkgver -f $_cvsmod
cd $_cvsmod
./autogen.sh
msg "CVS checkout done or server timeout"
msg "Starting make..."
cp -r ../$_cvsmod ../$_cvsmod-build
cd ../$_cvsmod-build
./configure --prefix=/usr
make || return 1
make DESTDIR=$startdir/pkg install || return 1
mkdir -p $startdir/pkg/usr/share/xmms/Skins
mv $startdir/pkg/usr/share/bmp/Skins/* $startdir/pkg/usr/share/xmms/Skins
rmdir $startdir/pkg/usr/share/bmp/Skins
rm -r $startdir/src/$_cvsmod-build
}
# vim:syntax=sh
[edit] SVN PKGBUILD 样例
假如您第一次对 PKGBUILD 使用 source 命令,它会填充(store) _svntrunk 和 _svnmod 变量。所以如果您运行:
source PKGBUILD svn log $_svntrunk --limit 1 | grep -m 1 -o "r.*" | cut -d \| -f 1 | sed s@r@@g
你可以得到用于 pkgver 的修正号
# Contributor: Lukas Sabota <punkrockguy318@comcast.net>
# Contributor: dibblethewrecker dibblethewrecker.at.jiwe.dot.org
pkgname=fluxbox-svn
pkgver=4084
pkgrel=1
pkgdesc="Fluxbox-svn is the bleeding edge version of a lightweight yet \
customizable windowmanager for X. This will checkout and package the latest SVN version."
url="http://www.fluxbox.org"
depends=('bash' 'x-server')
makedepends=('subversion')
conflicts=('blackbox' 'fluxbox' 'fluxbox-devel' 'fluxbox-cvs')
replaces=('fluxbox-cvs')
provides=('fluxbox')
_svntrunk=svn://svn.berlios.de/fluxbox/trunk
_svnmod=fluxbox
build() {
cd $startdir/src
svn co $_svntrunk --config-dir ./ -r $pkgver $_svnmod
cd $_svnmod
./autogen.sh
msg "SVN checkout done or server timeout"
msg "Starting make..."
mkdir ../$_svnmod-build
cd ../$_svnmod-build
# fix for crap fb issue
mkdir data
cp ../$_svnmod/data/keys data/
../$_svnmod/configure --prefix=/usr --enable-xinerama --enable-imlib2 --enable-debug
#./configure --prefix=/usr --enable-xinerama --enable-imlib2 --enable-debug
make || return 1
make DESTDIR=$startdir/pkg/ install
rm -r $startdir/src/$_svnmod-build
}
# vim:syntax=sh
[edit] GIT PKGBUILD 样例
pkgname=compiz-git
pkgver=20060707
pkgrel=1
pkgdesc="Composite and window manager for Xgl"
url="http://en.opensuse.org/Compiz"
license=""
depends=('xgl-cvs' 'mesa-xgl-cvs' 'cairo-devel' 'libxevie' \
'startup-notification' 'libpng' 'libxdamage' \
'libxrandr' 'libwnck-compiz' 'gnome-desktop' 'control-center' \
'libsvg-cairo' 'libxcomposite')
makedepends=('git')
conflicts=()
replaces=()
backup=()
install=compiz.install
source=(compiz-intel-copy-pixel-issue-workaround-1.diff)
md5sums=('10a157b86d528bca2be6731c5eaff7b3')
_gitroot="git://anongit.freedesktop.org/git/xorg/app/compiz"
_gitname="compiz"
build() {
export CFLAGS="$CFLAGS -I/opt/mesa-xgl-cvs/include"
cd $startdir/src
msg "Connecting to git.freedesktop.org GIT server...."
if [ -d $startdir/src/$_gitname ] ; then
cd $_gitname && git-pull origin
msg "The local files are updated."
else
git clone $_gitroot
fi
msg "GIT checkout done or server timeout"
msg "Starting make..."
cp -r $startdir/src/$_gitname $startdir/src/$_gitname-build
cd $startdir/src/$_gitname-build
patch -Np0 -i ${startdir}/src/compiz-intel-copy-pixel-issue-workaround-1.diff
ACLOCAL="aclocal -I /opt/gnome/share/aclocal" ./autogen.sh --host=${CHOST} \
--prefix=/usr \
--infodir=/usr/share/info \
--mandir=/usr/man \
--sysconfdir=/opt/gnome/etc \
--enable-gnome \
--enable-libsvg-cairo \
--enable-gconf-dump \
--disable-kde || return 1
make || return 1
make DESTDIR=$startdir/pkg install
find $startdir/pkg -type f -name '*.la' -exec rm {} \;
}
如您所见,我在 pkgname 后面使用 "-git" 后缀,另外两个变量 -- _gitroot 和 _gitname 用来表示包的“源”和包名字。 我需要解释一个 if 条件:
if [ -d $startdir/src/$_gitname ] ; then cd $_gitname && git-pull origin msg "The local files are updated." else git clone $_gitroot fi
因为我们有两个命令,一个用来更新,一个迎来取得代码。我把源代码 copy 到一个 "-build" 目录(在 cvs 和 svn 版本的包里面,我们也这样做)。
[edit] versionpkg - a makepkg wrapper for CVS/SVN builds
这是一个很简单的脚本,它能够让你在不改动 PKGBUILD 文件里面的日期或者修正号的前提下更新你的 CVS 或者 SVN 包。
简单地在你的 build 目录运行这个命令,代替 makepkg。这个脚本完全免除了用 backtick 扩展来设置 PKGBUILD 中的日期或者版本标记的必要。 (This script completely removes the need for backtick execution to set the date or tag version in PKGBUILDs.)
使用这个脚本之前;
- 确保在 PKGBUILD 的前10行的位置已经声明了 pkgver, 否则这个脚本不会正常工作!
- 确保你的文件包含了下面的变量以及 checkout 命令:
- CVS
_cvsroot=
- CVS 服务器根目录(The root of the CVS server) - 即的包含一个半角冒号 (:) 在用户名后面,就像上面提到的一样。
_cvsmod=
- 你要 check out 的 CVS 模块,如:
_cvsroot=":pserver:anonymous:@mplayerhq.hu:/cvsroot/ffmpeg" _cvsmod="ffmpeg"
- 下面这个 check out 的例子用到了上面提到的变来嗯。-D 选项对于正确使用
versionpkg是必须的,它和 -f 选项是很好的组合. 在不使用 -f 选项的情况下使用 -D 可能会导致错误
cvs -z9 -q -d $_cvsroot co -D $pkgver -f $_cvsmod
- -z 控制压缩级别(1低9高)
- -D 指定 check out 的日期,这这个脚本里面我们用 $pkgver 来在设置时间。
- -q 是 quiet (关闭详细信息)模式开关。
- SVN
_svntrunk=
- SVN trunk 地址 (译注,相当于 CVS root)
_svnmod=
- 在说一次,这个是你想要 ckeck out 的模块名,如:
_svntrunk=svn://svn.berlios.de/fluxbox/trunk _svnmod=fluxbox
- 下面这个例子使用了上面的变量。-r 选项对于正确使用
versionpkg是必要的(译注,这个是用来设置修改号的,显然).
svn co $_svntrunk --config-dir ./ -r $pkgver $_svnmod
- 这里的 -r 指定修改号, 我们用 $pkgver 来表示修改号。
[edit] 看看这个脚本!
为了提高安全性, versionpkg 现在可以直接从 [community] 安装,pacman -S versionpkg。 我强烈建议您这样做(I strongly recommend that you use that. )下面的脚本纯粹用来解释 :)
Changelog (修改记录):
- check for both CVS/SVN vars (检查 SVN 和 CVS vars)
- 如果失败了,就回退到上一个 pkgver ,以便允许正确的 gensync 操作(译注,我不知道 gensync, 从名字看应该是和更新有关,英文原文:If build fails revert to previous pkgver to allow correct gensync operation)
- 加入了有色消息(coloured messages)的支持
#!/bin/bash
# versionpkg - a makepkg wrapper for building CVS/SVN pkgs
# dibblethewrecker.at.jiwe.org
# makepkg configuration
[ -f /etc/makepkg.conf ] && source /etc/makepkg.conf
# SUBROUTINES
plain() {
if [ "$USE_COLOR" = "Y" -o "$USE_COLOR" = "y" ]; then
echo -e " \033[1;1m$1\033[1;0m" >&2
else
echo " $1" >&2
fi
}
msg() {
if [ "$USE_COLOR" = "Y" -o "$USE_COLOR" = "y" ]; then
echo -e "\033[1;32m==>\033[1;0m \033[1;1m$1\033[1;0m" >&2
else
echo "==> $1" >&2
fi
}
warning() {
if [ "$USE_COLOR" = "Y" -o "$USE_COLOR" = "y" ]; then
echo -e "\033[1;33m==> WARNING:\033[1;0m \033[1;1m$1\033[1;0m" >&2
else
echo "==> WARNING: $1" >&2
fi
}
error() {
if [ "$USE_COLOR" = "Y" -o "$USE_COLOR" = "y" ]; then
echo -e "\033[1;31m==> ERROR:\033[1;0m \033[1;1m$1\033[1;0m" >&2
else
echo "==> ERROR: $1" >&2
fi
return 1
}
source ./PKGBUILD
oldpkgver=$pkgver
if [ ! -z ${_cvsroot} ] && [ ! -z ${_cvsmod} ] ; then
cvsdate=`date +%Y%m%d`
sed -i "1,11 s|pkgver=$oldpkgver|pkgver=$cvsdate|" ./PKGBUILD
makepkg $@
if [ $? -gt 0 ] ; then
error "Reverting pkgver..."
sed -i "1,11 s|pkgver=$cvsdate|pkgver=$oldpkgver|" ./PKGBUILD
fi
elif [ ! -z ${_svntrunk} ] && [ ! -z ${_svnmod} ] ; then
svnrevno=`svn log $_svntrunk --limit 1 | grep -m 1 -o "r.*" | cut -d \| -f 1 | sed s@r@@g`
msg "Current revision number is $svnrevno"
if [ "${1}" != "-f" ] && [ "${oldpkgver}" == "${svnrevno}" ] ; then
error "No new revision available. (use -f to overwrite)"
exit
fi
sleep 3
sed -i "1,11 s|pkgver=$oldpkgver|pkgver=$svnrevno|" ./PKGBUILD
makepkg $@
if [ $? -gt 0 ] ; then
error "Reverting pkgver..."
sed -i "1,11 s|pkgver=$svnrevno|pkgver=$oldpkgver|" ./PKGBUILD
fi
else
error "No SVN or CVS variables found! Aborting..."
exit
fi
[edit] 译者声明
译者对本文的翻译全凭理解,部分内容可能没有经过实践,有错误的话,请直接编辑本文。